mod Maux

incl Mtex

incl Mtextm

rem 
  \para \bf  Some primitive recursive functions.  \end 

rem 
  \para \bf  Characteristic functions.  \end 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/2 Nef 'Tex_f2_char_nef'
  Nef(x,y) = 1 <- x != y
  Nef(x,y) = 0 <- x = y

rem 
  \para \bf  Binary arithmetic.  \end 

rem 
  \para Binary constructors \ft S0(x) \end and \ft S1(x) \end. See the module 
  \ft Standard \end. 

rem 
  \para Binary format \ft Nb(x) \end. See the module \ft Standard \end. 

rem 
  \para Binary size. 

fun Szb 'Tex_f1_nb_sz'
  Szb S0(x) = 0 <- x = 0
  Szb S0(x) = Szb(x)+1 <- x > 0
  Szb S1(x) = Szb(x)+1

rem 
  \para Binary concatenation. 

fun/2 Concb 'Tex_f2_tm_nb_conc'
  Concb(x,S0(y)) = x <- y = 0
  Concb(x,S0(y)) = S0 Concb(x,y) <- y > 0
  Concb(x,S1(y)) = S1 Concb(x,y)

rem 
  \para \bf  Operations on tuples.  \end 

rem 
  \para Predicate holding of non-empty tuples. 

pred/2 Tp 
  Tp(1,x1)
  Tp(n+2,x1,x) <- Tp(n+1,x)

rem 
  \para Its characteristic function. 

fun/2 Tpf 'Tex_f2_tm_char_tpf'
  Tpf(n,x) = 1 <- Tp(n,x)
  Tpf(n,x) = 0 <- ~Tp(n,x)

